package be.jeffcheasey88.peeratcode.parser.java;

import java.util.ArrayList;
import java.util.List;

import be.jeffcheasey88.peeratcode.parser.Token;
import be.jeffcheasey88.peeratcode.parser.java.Annotation.Annotable;
import be.jeffcheasey88.peeratcode.parser.java.Operation.OperationContainer;
import be.jeffcheasey88.peeratcode.parser.java.Variable.VariableContainer;

public class Function extends JavaElement implements Annotable, VariableContainer, OperationContainer{
	
	public static interface FunctionContainer{
		
		void addFunction(Function function);
		
	}
	
	private List<Annotation> annotations;
	
	private int mod;
	private Token generic;
	private Token type;
	private Token name;
	private List<Variable> parameters;
	private List<Token> throwables;
	
	private List<JavaElement> elements;
	
	public Function(int mod, Token type, Token name){
		this.mod = mod;
		this.type = type;
		this.name = name;
		this.annotations = new ArrayList<>();
		this.elements = new ArrayList<>();
	}
	
	public Function(int mod, Token generic, Token type, Token name){
		this(mod, type, name);
		this.generic = generic;
	}
	
	public Function(int mod, Token generic, Token type, Token name, List<Variable> parameters){
		this(mod, generic, type, name);
		this.parameters = parameters;
	}
	
	public Function(int mod, Token generic, Token type, Token name, List<Variable> parameters, List<Token> throwables){
		this(mod, generic, type, name, parameters);
		this.throwables = throwables;
	}

	@Override
	public void addAnnotation(Annotation annotation) {
		this.annotations.add(annotation);
	}

	@Override
	public void addVariable(Variable variable) {
		this.elements.add(variable);
	}

	@Override
	public void addOperation(Operation operation) {
		this.elements.add(operation);
	}

}
